<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="商品名称" prop="store_name">
                    <el-input v-model="formData.store_name" placeholder="请输入商品名称" />
                </el-form-item>
                <el-form-item label="商品图片" prop="image">
                    <material-picker v-model="formData.image" :limit="1" />
                </el-form-item>
                <el-form-item label="商品库存" prop="stock">
                    <el-input v-model="formData.stock" placeholder="请输入商品库存" />
                </el-form-item>
                <el-form-item label="商品销量" prop="sales">
                    <el-input v-model="formData.sales" placeholder="请输入商品销量" />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="storeBranchProductEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import {
    apiStoreBranchProductEditStock,
    apiStoreBranchProductDetail
} from '@/api/store_branch_product'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')

// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '重置门店库存' : '新增门店商品'
})

// 表单数据
const formData = reactive({
    id: '',
    store_name: '',
    image: '',
    stock: '',
	sales: ''
})

// 表单验证
const formRules = reactive<any>({
    cate_id: [{ required: true, message: '请输入商品分类', trigger: 'blur' }],
    store_name: [{ required: true, message: '请输入门店名称', trigger: 'blur' }],
    image: [{ required: true, message: '请输入商品图片', trigger: 'blur' }],
    price: [{ required: true, message: '请输入商品价格', trigger: 'blur' }],
    cost: [{ required: true, message: '请输入商品成本', trigger: 'blur' }],
    bar_code: [{ required: true, message: '请输入商品条码', trigger: 'blur' }],
    unit: [{ required: true, message: '请输入商品单位', trigger: 'blur' }],
    status: [{ required: true, message: '请输入商品状态', trigger: 'blur' }]
})

const unitList = ref([])

// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiStoreBranchProductDetail({
        id: row.id
    })
    setFormData(data)
}

// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData }
    await apiStoreBranchProductEditStock(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}

defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
